SystemOrganization addCategory: #'GMF-Window'!

Object subclass: #GMF
	instanceVariableNames: 'metaModel modelSource window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

!GMF class methodsFor: 'instance creation' stamp: 'MatusVolosin 7/24/2013 18:06'!
open
	 ^(super new initialize )
		
		createWindow;
		yourself.! !

!GMF methodsFor: 'testing' stamp: 'MatusVolosin 10/18/2013 21:11'!
clearPackage
	| package |
	
package := PackageInfo named: 'generatedClasses'.

package definedClasses do: [ :classToRemove | classToRemove removeFromSystem ].! !

!GMF methodsFor: 'MainWindow' stamp: 'MatusVolosin 10/26/2013 14:30'!
createFileMenu
	| fileMenu |
	fileMenu := window newMenu.
	fileMenu
		addToggle: 'Open' translated
		target: nil
		selector: #fileOpen.
	fileMenu lastItem font: window theme menuFont; 
		 icon: window theme smallOpenIcon;
		 keyText: ''.
	fileMenu
		addToggle: 'Save' translated
		target: nil
		selector: #saveFile
		getStateSelector: nil
		enablementSelector: nil.
	fileMenu lastItem font: window theme menuFont;
		 icon: window theme smallSaveIcon;
		 keyText: ''.
	fileMenu
		addToggle: 'Generate code' translated
		target: self
		selector: #testGenerate.
	fileMenu lastItem font: window theme menuFont;
		 icon: window theme smallPrintIcon;
		 keyText: ''.
	^ fileMenu! !

!GMF methodsFor: 'MainWindow' stamp: 'MatusVolosin 10/26/2013 14:56'!
createGenerateDialog
	| builder content |
	builder := UITheme builder.
	
	"content := builder newColumn: {
			((builder 
		 newListFor: self 
		list: #generateDialogContent
		selected: nil
		changeSelected: nil
		help: 'generate' ) minHeight: 100 ) minWidth: 300.
					}.
	dialog := ( builder newPluggableDialogWindow: 'Generate code' for: content ).

	builder openModal: dialog"
	content := builder newColumn: { 
		builder newLabelGroup: { 
		'The code has been successfully generated. All classes you find in package:' -> ( builder newLabel: '"generatedClasses"').
		 }.
	 }.
	(content openInWindowLabeled: 'Generate code') extent: 620@50.
	
	! !

!GMF methodsFor: 'MainWindow' stamp: 'MatusVolosin 10/10/2013 19:46'!
createTextDock
	^ window
		newTextEditorFor: self
		getText: #getModelSource 
		setText: #setModelSource:
		getEnabled: nil! !

!GMF methodsFor: 'MainWindow' stamp: 'MatusVolosin 10/18/2013 21:34'!
createToolbarButtons
	| fileMenu tools dock |
	fileMenu := self createFileMenu.
	tools := window newToolbar: {
				     	window
					newButtonFor: nil
					getState: nil
					action: #openFile 
					arguments: nil
					getEnabled: nil
					labelForm: window theme smallOpenIcon
					help: 'Open file' translated. 
					
					window
					newButtonFor: nil
					getState: nil
					action: #openFile 
					arguments: nil
					getEnabled: nil
					labelForm: window theme smallOpenIcon
					help: 'Open file' translated.
					window
					newButtonFor: nil
					getState: nil
					action: #saveFile
					arguments: nil
					getEnabled: nil
					labelForm: window theme smallSaveIcon
					help: 'Save file' translated. 
					window
					newButtonFor: self
					getState: nil
					action: #testGenerate
					arguments: nil
					getEnabled: nil
					labelForm: window theme smallPrintIcon
					help: 'Generate code' translated}.
	dock := window newToolDockingBar.
	dock
		add: 'File' translated
		font: window theme menuBarFont
		icon: window theme smallOpenIcon
		help: 'File operations' translated
		subMenu: fileMenu;
		 addMorphBack: tools.
	^dock.! !

!GMF methodsFor: 'MainWindow' stamp: 'MatusVolosin 10/18/2013 21:34'!
createWindow
	| dock text |
	window := StandardWindow new.
	window title: 'GMF in Pharo'.

	dock := self createToolbarButtons.
	text := self createTextDock.
	window
		addMorph: dock
		fullFrame: ((0 @ 0 corner: 1 @ 0) asLayoutFrame bottomOffset: dock minExtent y);
		
		addMorph: text
		fullFrame: ((0 @ 0 corner: 1 @ 1) asLayoutFrame topOffset: dock minExtent y).
		
	window
			themeChanged;
			openInWorld.! !

!GMF methodsFor: 'accessing' stamp: 'MatusVolosin 10/26/2013 14:26'!
generateDialogContent
	| content |
	content := OrderedCollection new.
	content add: '1. Checking OntoUML model rules'.
	content add: '2. Clearing package ''generatedClasses'''.
	content add: '3. Transform from OntoUML to UML'.
	content add: '4. Generate code'.
	^ content.
	! !

!GMF methodsFor: 'testing' stamp: 'MatusVolosin 10/10/2013 15:02'!
getModelSource
	^modelSource ifNil: [ modelSource := 'being := Kind name: ''Being''.
	method := Method name: ''isLive'' returnDataType: ''boolean''.
	being methods add: method.
	death := Phase name: ''Death''.
	death parent add: being.
	living := Phase name: ''Living''.
	living parent add: being.
	person := SubKind name: ''Person''.
	attr := Attribut
				name: ''birthNumber''
				dataType: ''string''
				quantity: 1.
	person attributs add: attr.
	attr := Attribut
				name: ''name''
				dataType: ''string''
				quantity: 1.
	person attributs add: attr.
	attr := Attribut
				name: ''dateOfBirth''
				dataType: ''date''
				quantity: ''0..1''.
	person attributs add: attr.
	method := Method name: ''age'' returnDataType: ''integer''.
	person methods add: method.
	person parent add: being.
	animal := SubKind name: ''Animal''.
	method := Method
				name: ''eat''
				returnDataType: ''boolean''
				abstract: true.
	method parameters add: ''food''.
	animal methods add: method.
	method := Method
				name: ''sound''
				returnDataType: ''string''
				instance: false.
	animal methods add: method.
	animal parent add: being.
	association := FormalAssociation
				name: ''has''
				start: person
				startQuantity: 1
				end: animal
				endQuantity: ''0..*''.
	person associations add: association.
	animal associations add: association.
	man := SubKind name: ''Man''.
	man parent add: person.
	woman := SubKind name: ''Woman''.
	woman parent add: person.
	child := SubKind name: ''Child''.
	child parent add: person.
	association := FormalAssociation
				name: ''wife''
				start: man
				startQuantity: 1
				end: woman
				endQuantity: 1.
	man associations add: association.
	woman associations add: association.
	association := FormalAssociation
				name: ''husband''
				start: woman
				startQuantity: 1
				end: man
				endQuantity: 1.
	man associations add: association.
	woman associations add: association.
	association := FormalAssociation
				name: ''mother''
				start: child
				startQuantity: ''0..*''
				end: woman
				endQuantity: 1.
	child associations add: association.
	woman associations add: association.
	association := FormalAssociation
				name: ''children''
				start: woman
				startQuantity: 1
				end: child
				endQuantity: ''0..*''.
	child associations add: association.
	woman associations add: association.
	association := FormalAssociation
				name: ''girlFriends''
				start: man
				startQuantity: ''0..*''
				end: woman
				endQuantity: ''0..*''.
	man associations add: association.
	woman associations add: association.
	association := FormalAssociation
				name: ''boyFriends''
				start: woman
				startQuantity: ''0..*''
				end: man
				endQuantity: ''0..*''.
	man associations add: association.
	woman associations add: association.
	dog := SubKind name: ''Dog''.
	method := Method name: ''eat'' returnDataType: ''boolean''.
	method parameters add: ''food''.
	dog methods add: method.
	method := Method
				name: ''sound''
				returnDataType: ''string''
				instance: false.
	dog methods add: method.
	dog parent add: animal.
	
	metaModel := MetaModel new.
	metaModel addElement: being.
	metaModel addElement: death.
	metaModel addElement: living.
	metaModel addElement: person.
	metaModel addElement: animal.
	metaModel addElement: man.
	metaModel addElement: woman.
	metaModel addElement: dog.
	metaModel addElement: child'. ]
	! !

!GMF methodsFor: 'initialize-release' stamp: 'MatusVolosin 10/26/2013 13:45'!
initialize
	generateDialogContent := OrderedCollection new.! !

!GMF methodsFor: 'accessing' stamp: 'MatusVolosin 10/7/2013 14:55'!
modelSource
	^ modelSource! !

!GMF methodsFor: 'testing' stamp: 'MatusVolosin 10/10/2013 15:12'!
setModelSource: xSource
	modelSource := xSource.
	self changed: #getModelSource.! !

!GMF methodsFor: 'testing' stamp: 'MatusVolosin 10/26/2013 14:30'!
testGenerate
	| UMLElements data |
	self changed: #getModelSource.
	self createGenerateDialog.
	self clearPackage.
	metaModel := Compiler evaluate: modelSource.
	UMLElements := TransformToUML dataToTransform: metaModel modelElements.
	UMLElements transformAll.
	data := DataForGenerator UMLModel: UMLElements transformedElements.
	UMLElements dataForGenerator: data dataForGenerator.
	
	CodeGenerator setDataWithAll: UMLElements dataForGenerator! !

!GMF methodsFor: 'accessing' stamp: 'MatusVolosin 10/10/2013 19:38'!
window
	^ window! !

!GMF methodsFor: 'accessing' stamp: 'MatusVolosin 10/10/2013 19:38'!
window: anObject
	window := anObject! !
